unit ShowIP;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, HTTPApp, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, Winsock, ExtCtrls, clipbrd;


type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    IdHTTP1: TIdHTTP;
    Memo1: TMemo;
    Label1: TLabel;
    HOST: TMemo;
    Label2: TLabel;
    IPaddr: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Edit1: TEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);

 
   
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Host: TMemo;
IPaddr: TMemo;

implementation

{$R *.dfm}

function HostToIP(Name: string; var Ipi: string): Boolean; 
var 
  wsdata : TWSAData;
  hostName : array [0..255] of char; 
  hostEnt : PHostEnt; 
  addr : PChar; 
begin
  WSAStartup ($0101, wsdata);
  try 
    gethostname (hostName, sizeof (hostName)); 
    StrPCopy(hostName, Name); 
    hostEnt := gethostbyname (hostName); 
    if Assigned (hostEnt) then 
      if Assigned (hostEnt^.h_addr_list) then begin 
        addr := hostEnt^.h_addr_list^; 
        if Assigned (addr) then begin 
          IPi := Format ('%d.%d.%d.%d', [byte (addr [0]),
          byte (addr [1]), byte (addr [2]), byte (addr [3])]); 
          Result := True; 
        end 
        else 
          Result := False; 
      end 
      else
        Result := False
    else begin 
      Result := False; 
    end; 
  finally 
    WSACleanup; 
  end 
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
const
  StartText = 'Current IP Address: ';
  EndText = '</body>';
var
  StartPos, Leng: integer;
  HTMLBody, IP: string;
  PostData: TStringList;
  Response: TStringStream;
  wVerReq: WORD;
  wsaData: TWSAData;
  i: pchar;
  h: PHostEnt;
  c: array[0..128] of char;
  IPi: string;


begin
  Response := TStringStream.Create('');
  PostData := TStringList.Create;
  wVerReq := MAKEWORD(1, 1);
  WSAStartup(wVerReq, wsaData);
  {  () }
  GetHostName(@c, 128);
  h := GetHostByName(@c);
  Host.Lines.Text := h^.h_Name; //Host  () 
  { IP}
  i := iNet_ntoa(PInAddr(h^.h_addr_list^)^);
  IPaddr.Lines.Text := i; // IPaddr  IP-
  WSACleanup;
  if HostToIp(Edit1.Text, IPi)
then Edit1.Text := IPi;


  try
    IdHTTP1.Post('http://checkip.dyndns.org/', PostData, Response);
    Memo1.Lines.Text := Response.DataString;      //    :))

  finally
    Response.Free;
    PostData.Free;
  end;
  HTMLBody := Memo1.Text;
  StartPos := Pos(StartText, HTMLBody) + Length(StartText);
  Leng := Pos(EndText, HTMLBody) - StartPos;
  IP := Copy(HTMLBody, StartPos, Leng);
  Memo1.Lines.Text := IP;
  Label1.Caption := IP;
  Label2.Caption := Host.Text;
  Label3.Caption :=  IPaddr.Text;
  Label8.Caption :=  IPi;

  end;
  procedure TForm1.Button1Click(Sender: TObject);
begin
close;
end;

end.



